你真的知道吗?catch、finally和return哪个先执行

  • 你真的知道吗?catch、finally和return哪个先执行已关闭评论
  • 85 次浏览
  • A+
所属分类:.NET技术
摘要

我的一位朋友前阵子遇到一个问题,问题的核心就是try……catch……finally中catch和finally代码块到底哪个先执。这个问题看起来很简单,当然是“catch先执行、finally后执行”了?真的是这样吗?

我的一位朋友前阵子遇到一个问题,问题的核心就是try……catch……finally中catch和finally代码块到底哪个先执。这个问题看起来很简单,当然是“catch先执行、finally后执行”了?真的是这样吗?

有下面一段C#代码,请问这段代码的执行结果是什么?

public static void Main(string[] args)  {        try        {              A();        }        catch        {              Console.WriteLine("catch!!!");        }  }  static void A()  {        try        {              throw new Exception();        }        finally        {               Console.WriteLine("finally!!!");        }  }

 

A()方法的try代码块中抛出了异常,而A方法没有处理这个异常,所以Main方法的catch代码块会捕获这个异常,但是A()方法中又有finally代码块,那么到底是异常抛出后先执行Main方法的catch代码块呢还是先执行A()方法中的finally代码块呢?运行一下程序就能看出来,是finally代码块执行,结果如下所示。

finally!!!  catch!!!

 

为什么呢?这需要从方法调用的异常对象如何传递给被调用方法讲起。在一段代码调用一个方法的时候,被调用的方法会把返回值、异常对象等放到一个特定的位置,这个位置叫做Stack Frame,调用者代码会从这个特定的位置获得被调用方法的返回值、异常对象等信息。因此,无论是throw异常的时候还是return返回值的时候,被调用的方法只是把异常对象或者返回值放到了这个特定的位置,在return或者throw执行之后,如果方法中还有finally等没有执行完成的代码,那么这些代码仍然会在return、throw之后继续执行,然后方法执行才会结束,之后调用这个方法的代码才会从Stack Frame中读取到返回值或者获取到被调用的方法抛出的异常对象。因此,上面的代码才会先执行finally然后才执行catch。

明白了这个道理,请回答一下,下面代码的执行结果是什么?

public static void Main(string[] args)  {        try  {  A();  }  catch(Exception ex)  {  Console.WriteLine(ex.Message);  }  }  static void A()  {        try        {              throw new Exception("aa");        }        finally        {              throw new Exception("bb");        }  }

 

上面这是一段很特殊的代码,在try代码块中抛出了一个异常(信息是aa),在finally中也抛出了一个异常(信息是bb),那么程序实际打印出来的异常信息是什么呢?上面程序执行结果是“bb”。通过上面的分析不难理解其原理:try代码块中的throw new Exception("aa")把方法的异常对象设置为Exception("aa"),而finall代码块中的throw new Exception("bb")又把方法的异常对象修改为Exception("bb"),因此最终方法抛出的异常对象是Exception("bb")。

接下来,我们再来捉弄一下方法的返回值,我们尝试在finally代码块中修改方法的返回值。不幸的是(也可以说,幸运的是),C#禁止我们在finally代码块使用return语句,不过我们可以在Java中做这样的尝试,如下Java代码所示:

public static void main(String[] args)  {        System.out.println(A());  }  static int A()  {        try        {              return 1;        }        finally        {              return 2;        }  }

 

我们在try代码块中通过return 1把方法的返回值设置为1,但是在finally代码块中又把方法的返回值设置为2,因此方法的最终返回值就是2。

综上所述,一个方法中通过return设定返回值或者throw抛出异常的时候,方法并没有立即返回,只是在Stack Frame上保存了这个返回值或者异常对象,然后会继续执行finally中的代码,如果我们在finally代码块中修改了返回值或者抛出了新的异常,那么最终的调用中获得的返回值或者捕获的对象就是修改后的返回值或者异常对象。